//DKS - new file for gp2x-specific defines and functions
#ifndef GP2X_HPP_
#define GP2X_HPP_


#include <SDL.h>
//#include <SDL/SDL_gp2x.h>

#define INPUT_DPAD	(0)
#define INPUT_MOUSE	(1)
#define INPUT_TS		(2)
extern int gp2x_input; // set to one of the above on startup
extern int gp2x_ts_lefthanded;	// set to 1 if using left-handed version of touchscreen controls

#define GP2X_BUTTON_UP              (0)
#define GP2X_BUTTON_DOWN            (4)
#define GP2X_BUTTON_LEFT            (2)
#define GP2X_BUTTON_RIGHT           (6)
#define GP2X_BUTTON_UPLEFT          (1)
#define GP2X_BUTTON_UPRIGHT         (7)
#define GP2X_BUTTON_DOWNLEFT        (3)
#define GP2X_BUTTON_DOWNRIGHT       (5)
#define GP2X_BUTTON_CLICK           (18)
#define GP2X_BUTTON_A               (12)
#define GP2X_BUTTON_B               (13)
#define GP2X_BUTTON_X               (14)
#define GP2X_BUTTON_Y               (15)
#define GP2X_BUTTON_L               (10)
#define GP2X_BUTTON_R               (11)
#define GP2X_BUTTON_START           (8)
#define GP2X_BUTTON_SELECT          (9)
#define GP2X_BUTTON_VOLUP           (16)
#define GP2X_BUTTON_VOLDOWN         (17)


extern SDL_Joystick *joy_gp2x;

extern int last_joy_dir;	// holds last direction F100 model joystick was pressed, and is used for aiming
									// on non-touchscreen models. 0-337.5 (degrees)  
extern int dpad_not_centered; 	
extern int gp2x_dpad[8];

//DKS - these are the emulated cursor coordinates.  The real 0-319, 0-199 coordinates are
//	gotten by shifting each to the right 16.  They are like this so we can increment a bit
//	at a time in the input loop and get good responsiveness.
extern long priv_mousex, priv_mousey; 	// in event.cpp
extern int priv_loadscreen;	// are we at a file load/save screen?  if so, we display the
									// cursor and emulate the movement even when the game "state"
									// is running.
extern int last_joy_dir; // holds last direction of dpad, in degrees, right is 0 degrees, up is 90
extern int last_player_dir;	// holds last player direction so he points towards direction last walked, 180 if left
extern int dpad_not_centered;

//DKS defined in sdlport.video.cpp
extern int gp2x_ts_lefthanded;	// 0 if left-handed touchscreen controls, 1 if righthanded

//DKS defined in sdlport/sound.cpp
extern float gp2x_mixervol;	// Current mixer volume
extern float gp2x_mixervolatstartup; // Stored mixer volume from startup


// new private GP2X functions declared in event.cpp:
Uint8 priv_GetMouseState( int *x, int *y);
int dpad_update(void);

extern void gp2x_set_volume(int);
extern int gp2x_get_volume(void);
//extern void gp2x_change_volume(int);

#endif
