/************************
 * sound.c
 * SDL port for Abuse
 * by Anthony Kruize
 ************************/

#include <SDL.h>

#include "sound.hpp"
#include "jmalloc.hpp"
#include "readwav.hpp"
#include "specs.hpp"
#include "setup.h"

//DKS
#include "SDL_mixer.h"
#include 	<sys/ioctl.h>
#include	<sys/soundcard.h>
#include	<unistd.h>
#include	<fcntl.h>

float gp2x_mixervol	= 67.0;	// Current mixer volume
float gp2x_mixervolatstartup = 67.0;	// Stored mixer volume from startup

//DKS - new
void gp2x_set_volume(int newvol)
{
    if ((newvol >= 0) && (newvol <= 100)) {
	    unsigned long soundDev = open("/dev/mixer", O_RDWR);
	    if (soundDev != -1)
	    {
	        //int vol =(((newvol*0x50)/100)<<8)|((newvol*0x50)/100);
	        int vol = ((newvol << 8) | newvol);
	        ioctl(soundDev, SOUND_MIXER_WRITE_PCM, &vol);
	        close(soundDev);
	    }
    }
}

//DKS - new, called at startup so we can 
// 	set it back to what it was when we exit.  
// Returns 0-100, current mixer volume, -1 on error.
int gp2x_get_volume(void)
{
	int vol = -1;
    unsigned long soundDev = open("/dev/mixer", O_RDONLY);
    if (soundDev != -1)
    {
        ioctl(soundDev, SOUND_MIXER_READ_PCM, &vol);
        close(soundDev);
        if (vol != -1) {
	         //just return one channel , not both channels, they're hopefully the same anyways
        	 return (vol & 0xFF);
        }
    }
	return vol;
}

////DKS - new
////Will change the volume level up or down, if amount is positive or negative. Will do volume level clamping.
//void gp2x_change_volume(int amount) {
//	//DKS - limit amount volume can be changed when we're down low already..
//	//		So headphone users can set a good volume
//	if ((amount > +1) && gp2x_current_volume <= 12) {
//		amount = +1;
//	} else if ((amount < -1) && gp2x_current_volume <= 12) {
//		amount = -1;
//	}
//	
//	gp2x_current_volume += amount;
//	 
//	if (gp2x_current_volume > 100) {
//		gp2x_current_volume = 100;
//	} else if (gp2x_current_volume < 0) {
//		gp2x_current_volume = 0;
//	}
//	gp2x_set_volume(gp2x_current_volume);
//}

//DKS - after conversion to SDL_mixer, no need to keep a list of playing sound effects
//class effect_handle
//{
//public:
//	effect_handle	*prev;		// Handle to the previous effect
//	effect_handle	*next;		// Handle to the next effect
//	Uint8			*data;		// Audio data
//	Uint8			*pos;		// current playing position in the data
//	Uint32			length;		// Length of the data
//	Uint32			volume;		// Volume for this effect.
//
//	effect_handle( effect_handle *Next )
//	{
//		next = Next;
//		if( next )
//		{
//			next->prev = this;
//		}
//		prev = NULL;
//		data = NULL;
//		pos = NULL;
//	}
//
//	~effect_handle()
//	{
//		if( next )
//		{
//			next->prev = prev;
//		}
//		if( prev )
//		{
//			prev->next = next;
//		}
//	}
//};

//static effect_handle * fx_list = NULL;

extern flags_struct flags;
static int sound_enabled = 0;
static int sound_initialized = 0;
//DKS
//static SDL_AudioSpec audioObtained;

//DKS - no need for our own mixer with conversion to SDL_mixer
////
//// mix_audio
////
//// Do the actual playing of the audio by looping through our effects list
//// and mixing each sample.
////
//void mix_audio(void *udata, Uint8 *stream, int len)
//{
//	effect_handle *handle = fx_list;
//
//	while( handle )
//	{
//		if( handle->length > 0 && handle->pos )
//		{
//			len = ( len > (int)handle->length ? handle->length : len );
//			SDL_MixAudio( stream, handle->pos, len, handle->volume );
//			handle->pos += len;
//			handle->length -= len;
//			handle = handle->next;
//		}
//		else
//		{
//			// update the list pointer if we're deleting the first node
//			if( fx_list == handle )
//			{
//				fx_list = handle->next;
//			}
//			effect_handle *tmp = handle->next;
//			if( !flags.mono )
//			{
//				// delete the audio buffer
//				free( handle->data );
//			}
//			delete handle;
//			handle = tmp;
//		}
//	}
//}

//DKS - converting all audio to use SDL_mixer
////
//// sound_init()
//// Initialise audio
////
//int sound_init( int argc, char **argv )
//{
//	SDL_AudioSpec audioWanted;
//	char *sfxdir, *datadir;
//	FILE *fd = NULL;
//
//	// Disable sound if requested.
//	if( flags.nosound )
//	{
//		// User requested that sound be disabled
//		printf( "Sound : Disabled (-nosound)\n" );
//		return 0;
//	}
//
//	// Check for the sfx directory, disable sound if we can't find it.
//	datadir = get_filename_prefix();
//	sfxdir = (char *)jmalloc( strlen( datadir ) + 5 + 1, "sfxdir" );
//	sprintf( sfxdir, "%s/sfx/", datadir );
//	if( (fd = fopen( sfxdir,"r" )) == NULL )
//	{
//		// Didn't find the directory, so disable sound.
//		printf( "Sound : Disabled (couldn't find the sfx directory)\n" );
//		return 0;
//	}
//	jfree( sfxdir );
//
//	audioWanted.freq = 11025;
//	audioWanted.format = AUDIO_U8;
//	audioWanted.channels = 2 - flags.mono;
//	audioWanted.samples = 128;
//	audioWanted.callback = mix_audio;
//	audioWanted.userdata = NULL;
//
//	// Now open the audio device
//	if( SDL_OpenAudio( &audioWanted, &audioObtained ) < 0 )
//	{
//		printf( "Sound : Unable to open audio - %s\nSound : Disabled (error)\n", SDL_GetError() );
//		return 0;
//	}
//
//	sound_enabled = 1;
//	printf( "Sound : Enabled\n" );
//
//	SDL_PauseAudio( 0 );
//
//	// It's all good
//	return sound_enabled;
//}
//
// sound_init()
// Initialise audio
//
int sound_init( int argc, char **argv )
{
//	SDL_AudioSpec audioWanted;
	char *sfxdir, *datadir;
	FILE *fd = NULL;

	// Disable sound if requested.
	if( flags.nosound )
	{
		// User requested that sound be disabled
		printf( "Sound : Disabled (-nosound)\n" );
		return 0;
	}

	// Check for the sfx directory, disable sound if we can't find it.
	datadir = get_filename_prefix();
	sfxdir = (char *)jmalloc( strlen( datadir ) + 5 + 1, "sfxdir" );
	sprintf( sfxdir, "%s/sfx/", datadir );
	
	if( (fd = fopen( sfxdir,"r" )) == NULL )
	{
		// Didn't find the directory, so disable sound.
		printf( "Sound : Disabled (couldn't find the sfx directory)\n" );
		return 0;
	}
	jfree( sfxdir );

//	audioWanted.freq = 11025;
//	audioWanted.format = AUDIO_U8;
//	audioWanted.channels = 2 - flags.mono;
//	audioWanted.samples = 128;
//	audioWanted.callback = mix_audio;
//	audioWanted.userdata = NULL;

//	// Now open the audio device
//	if( SDL_OpenAudio( &audioWanted, &audioObtained ) < 0 )
//	{
//		printf( "Sound : Unable to open audio - %s\nSound : Disabled (error)\n", SDL_GetError() );
//		return 0;
//	}

//	DKS getting some popping with just 128:
//	if(Mix_OpenAudio(22050, MIX_DEFAULT_FORMAT, 2, 128)==-1) {
//	if(Mix_OpenAudio(22050, MIX_DEFAULT_FORMAT, 2, 256)==-1) {
	if(Mix_OpenAudio(22050, MIX_DEFAULT_FORMAT, 2, 512)==-1) {
		printf("Mix_OpenAudio: %s\n", Mix_GetError());
		printf( "Sound : Unable to open audio - sound disabled.\n");
		return 0;
	} else
		

	//DKS - if I don't do this, for some reason I get distorted sound forever after launching
	//the program
	//Actually, now I think I might have only experienced this problem using the
	//cradle and USB keyboard/mouse.  Might have been caused by not having a 5V adapter
	//for the cradle.
	gp2x_set_volume((int)gp2x_mixervolatstartup);

//DKS - this actually is handled using two bits not one
//	sound_enabled = 1;
	sound_enabled = SFX_INITIALIZED + MUSIC_INITIALIZED;

	sound_initialized = 1;

	printf( "Sound : Enabled\n" );

//	SDL_PauseAudio( 0 );

	// It's all good
	return sound_enabled;
}

//DKS
////
//// sound_uninit
////
//// Shutdown audio and release any memory left over.
////
//void sound_uninit()
//{
//	if( sound_enabled )
//	{
//		SDL_PauseAudio( 1 );
//		while( fx_list )
//		{
//			effect_handle *last = fx_list;
//			fx_list = fx_list->next;
//			jfree( last );
//		}
//		SDL_CloseAudio();
//	}
//}
//
// sound_uninit
//
// Shutdown audio and release any memory left over.
//
void sound_uninit()
{
	if( sound_enabled && sound_initialized)
	{
		
		sound_initialized = 0;
		sound_enabled = 0;
		
//		SDL_PauseAudio( 1 );
		Mix_Pause(-1);
//		while( fx_list )
//		{
//			effect_handle *last = fx_list;
//			fx_list = fx_list->next;
//			jfree( last );
//		}
//		SDL_CloseAudio();
		Mix_CloseAudio();
	}
}

//DKS
////
//// sound_effect constructor
////
//// Read in the requested .wav file.
////
//sound_effect::sound_effect( char * filename )
//{
//	if( sound_enabled )
//	{
//		long sample_speed;
//		data = (void *)read_wav( filename, sample_speed, size );
//	}
//}
//
// sound_effect constructor
//
// Read in the requested .wav file.
//
sound_effect::sound_effect( char * filename )
{
	if( sound_enabled && sound_initialized)
	{
//		long sample_speed;
//		data = (void *)read_wav( filename, sample_speed, size );

		char fullname[200];
		sprintf(fullname, "%s%s", get_filename_prefix(), filename);
//		printf("Loading sound file: %s\n", fullname);
		sample=Mix_LoadWAV(fullname);
		if(!sample) {
			 printf("Mix_LoadWAV: %s\n", Mix_GetError());
			 exit(0);
		}
	}
}

//DKS
////
//// sound_effect destructor
////
//// Release the audio data.
////
//sound_effect::~sound_effect()
//{
//	if( sound_enabled )
//	{
//		if( data )
//		{
//			jfree( data );
//		}
//	}
//}
//
// sound_effect destructor
//
// Release the audio data.
//
sound_effect::~sound_effect()
{
	if( sound_initialized )
	{
//		if( data )
//		{
//			jfree( data );
//		}
		if (sample)
		{
			Mix_FreeChunk(sample);
			sample=NULL; 
		}
	}
}

//DKS
////
//// sound_effect::play
////
//// Insert a new effect_handle into the list and modify the audio
//// if we're doing stereo.
//// panpot defines the pan position for the sound effect.
////   0   - Completely to the right.
////   128 - Centered.
////   255 - Completely to the left.
////
//void sound_effect::play( int volume, int pitch, int panpot )
//{
//	if( sound_enabled )
//	{
//		SDL_LockAudio();
//
//		fx_list = new effect_handle( fx_list );
//		if( fx_list == NULL )
//		{
//			printf( "Sound : ERROR - Failed to create new effect.\n" );
//			SDL_UnlockAudio();
//			return;
//		}
//
//		if( !flags.mono )
//		{
//			unsigned int i;
//			Uint32 cvtBufferSize;
//			SDL_AudioCVT audiocvt;
//
//			// Do some audio conversion
//			SDL_BuildAudioCVT( &audiocvt, AUDIO_U8, 1, 11025, audioObtained.format, audioObtained.channels, audioObtained.freq );
//			audiocvt.buf = (Uint8 *)malloc( size * audiocvt.len_mult );
//			audiocvt.len = size;
//			memcpy( audiocvt.buf, data, size );
//			SDL_ConvertAudio( &audiocvt );
//			cvtBufferSize = (Uint32)((double)size * audiocvt.len_ratio);
//
//			// Adjust for requested pan position
//			if( panpot != 128 )
//			{
//				if( panpot > 128 )
//				{
//					// Pan to the left
//					panpot = (panpot - 255) * -1;
//					for( i = 1 ; i <= cvtBufferSize; i += 2 )
//					{
//						audiocvt.buf[i] = (((audiocvt.buf[i] - 128) * panpot) / 128) + 128;
//					}
//				}
//				else
//				{
//					// Pan to the right
//					for( i = 0 ; i < cvtBufferSize; i += 2 )
//					{
//						audiocvt.buf[i] = (((audiocvt.buf[i] - 128) * panpot) / 128) + 128;
//					}
//				}
//			}
//
//			fx_list->data = audiocvt.buf;
//			fx_list->pos = audiocvt.buf;
//			fx_list->length = cvtBufferSize;
//			fx_list->volume = volume;
//		}
//		else
//		{
//			// Only doing mono so don't mess with the audio data.
//			fx_list->data = (Uint8 *)data;
//			fx_list->pos = (Uint8 *)data;
//			fx_list->length = size;
//			fx_list->volume = volume;
//		}
//		SDL_UnlockAudio();
//	}
//}
//
// sound_effect::play
//
// Insert a new effect_handle into the list and modify the audio
// if we're doing stereo.
// panpot defines the pan position for the sound effect.
//   0   - Completely to the right.
//   128 - Centered.
//   255 - Completely to the left.
//
void sound_effect::play( int volume, int pitch, int panpot )
{

	//DKS - pitch parameter was ignored, max volume appears to be 127 in the game.

	if( sound_enabled  && sound_initialized)
	{
//		SDL_LockAudio();

//		fx_list = new effect_handle( fx_list );
//		if( fx_list == NULL )
//		{
//			printf( "Sound : ERROR - Failed to create new effect.\n" );
//			SDL_UnlockAudio();
//			return;
//		}

//		if( !flags.mono )
//		{
//			unsigned int i;
//			Uint32 cvtBufferSize;
//			SDL_AudioCVT audiocvt;
//
//			// Do some audio conversion
//			SDL_BuildAudioCVT( &audiocvt, AUDIO_U8, 1, 11025, audioObtained.format, audioObtained.channels, audioObtained.freq );
//			audiocvt.buf = (Uint8 *)malloc( size * audiocvt.len_mult );
//			audiocvt.len = size;
//			memcpy( audiocvt.buf, data, size );
//			SDL_ConvertAudio( &audiocvt );
//			cvtBufferSize = (Uint32)((double)size * audiocvt.len_ratio);
//
//			// Adjust for requested pan position
//			if( panpot != 128 )
//			{
//				if( panpot > 128 )
//				{
//					// Pan to the left
//					panpot = (panpot - 255) * -1;
//					for( i = 1 ; i <= cvtBufferSize; i += 2 )
//					{
//						audiocvt.buf[i] = (((audiocvt.buf[i] - 128) * panpot) / 128) + 128;
//					}
//				}
//				else
//				{
//					// Pan to the right
//					for( i = 0 ; i < cvtBufferSize; i += 2 )
//					{
//						audiocvt.buf[i] = (((audiocvt.buf[i] - 128) * panpot) / 128) + 128;
//					}
//				}
//			}
//
//			fx_list->data = audiocvt.buf;
//			fx_list->pos = audiocvt.buf;
//			fx_list->length = cvtBufferSize;
//			fx_list->volume = volume;
//		}
//		else
//		{
//			// Only doing mono so don't mess with the audio data.
//			fx_list->data = (Uint8 *)data;
//			fx_list->pos = (Uint8 *)data;
//			fx_list->length = size;
//			fx_list->volume = volume;
//		}
//		SDL_UnlockAudio();

		int channel_used = Mix_PlayChannel(-1, sample, 0);
		if (channel_used != -1)
		{
			Mix_Volume(channel_used, volume);
			if ((panpot > 128) || (panpot < 127))
			{
				//only apply the panning effect if really necessary
				Mix_SetPanning(channel_used, 255 - panpot, panpot);
			}
		}
	}
}


//DKS - I guess I tried a little harder than the last guy, I got songs working
//but I converted them from HMI to MP3 first, using an old copy of Winamp and some
//awesome MIDI soundfonts.  Not all the songs referenced in the lisp file sfx.lsp are
//present in the redistributable Abuse pacakges, so I am having to modify it.
////
//// We don't handle songs.  These are just stubs to basically do nothing.
//// I tried using SDL_mixer to do this, but with no success.
////
//song::song( char * filename )
//{
//	data = NULL;
//	Name = strcpy((char *)jmalloc( strlen( filename ) + 1, "song name" ), filename );
//	song_id = 0;
//}
//
song::song( char * filename )
{
//DKS
//	data = NULL;
//	Name = strcpy((char *)jmalloc( strlen( filename ) + 1, "song name" ), filename );
	char fullname[200];
	sprintf(fullname, "%s%s", get_filename_prefix(), filename);

	//	DKS - I decided it was better to just change hmi extension to mp3 elsewhere in code.
//	//DKS - replace .hmi extensions of songnames with mp3 extensions:
//	int tmpint = strlen(fullname);
//	strcpy(fullname+tmpint-3, "mp3");
	
	printf("Loading music file: %s\n", fullname);
	
	// Don't load music if all sound is disabled
	if( flags.nosound || !sound_enabled || !sound_initialized)
	{
		music = NULL;
	} else {
		music=Mix_LoadMUS(fullname);
		if(!music) {
			 printf("error: Mix_LoadMUS(\"%s\"): %s\n", fullname, Mix_GetError());
		}	
	}
}


//DKS
//song::~song()
//{
//	if( playing() )
//	{
//		stop();
//	}
//	if( data )
//	{
//		jfree( data );
//	}
//	jfree( Name );
//}
song::~song()
{
	if (sound_initialized) 
	{
		if( playing() )
		{
			stop();
		}

		if (music) {
			Mix_FreeMusic(music);
			music = NULL;
		}
	}

//	if( data )
//	{
//		jfree( data );
//	}
//	jfree( Name );

}

////DKS
//void song::play( unsigned char volume )
//{
//	song_id = 1;
//}
void song::play( unsigned char volume )
{
	//DKS - debugging
//	printf("DKS debug in sound.cpp, sound::play, Name=%s\n", Name);
//	song_id = 1;

	if (music && !flags.nosound && sound_enabled && sound_initialized)
	{
//		printf("DKS debug.. song should be playing\n");
		Mix_PlayMusic(music, 0);
		Mix_VolumeMusic(volume);
	}
}

//DKS
//void song::stop( long fadeout_time )
//{
//	song_id = 0;
//}
void song::stop( long fadeout_time )
{
	if (music && !flags.nosound && sound_enabled && sound_initialized)
	{
		if (fadeout_time > 0) {
			//			DKS - this never seems to be used, which is OK.
//			printf("DKS debug: fading out music for %d ms\n", fadeout_time);
			Mix_FadeOutMusic(fadeout_time);
		} else {
			Mix_HaltMusic();
		}
	}
}

//DKS
//int song::playing()
//{
//	return song_id;
//}
int song::playing()
{
//	return song_id;
	if (music && !flags.nosound && sound_enabled && sound_initialized) 
	{
		return Mix_PlayingMusic();
	} else {
		return 0;
	}
}

//DKS
//void song::set_volume( int volume )
//{
////	do nothing...
//}
void song::set_volume( int volume )
{
	if (!flags.nosound && sound_enabled && sound_initialized)
	{
		Mix_VolumeMusic(volume);
	}
}
